<?php

namespace App\Models\Customer;

use App\Entities\Customer\PointEntity;

class PointModel extends CustomerModel
{
    const TABLE = "pointinfo";
    const PK = "uid";
    const TITLE = "title";
    protected $table            = self::TABLE;
    protected $primaryKey       = self::PK;
    protected $returnType       = PointEntity::class;
    protected $allowedFields = [
        "user_uid",
        "clientinfo_uid",
        "title",
        "amount",
        "status",
        "updated_at"
    ];
    public function __construct()
    {
        parent::__construct();
    }
    public function getFormRule(string $action, string $field): string
    {
        if (is_array($field)) {
            throw new \Exception(__FUNCTION__ . "=> field가 array 입니다.\n" . var_export($field, true));
        }
        switch ($field) {
            case "user_uid":
            case "clientinfo_uid":
            case "amount":
                $rule  = "required|numeric";
                break;
            case "title":
            case "status":
                $rule = "required|trim|string";
                break;
            default:
                $rule = parent::getFormRule($action, $field);
                break;
        }
        return $rule;
    }
}
